## libflame 5.2.0

=== Makefile ===

#
# Makefile
#
# Field G. Van Zee
#
# Top-level makefile for libflame linear algebra library.
#
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        libs libflame \
        check-env check-env-config check-env-fragments \
        flat-headers \
        test \
        install-headers install-libs install-lib-symlinks \
        clean cleanmk cleanh cleanlib cleanleaves distclean \
        install \
        uninstall-libs uninstall-lib-symlinks uninstall-headers



# Accept an abbreivated request for verbosity (e.g. 'make V=1 ...')
ifeq ($(V),1)
ENABLE_VERBOSE := yes
endif

ifeq ($(V),0)
ENABLE_VERBOSE := no
endif



#
# --- Include architecture-specific variable definitions ----------------------
#

# Avoid catting the config.sys_type file unless it exists. This makes the
# output of things like 'make distclean' (when the directory is already
# clean) less confusing.
ifneq ($(wildcard config.sys_type),)
# The host string will uniquely identify the current host (as much
# as is reasonable) for purposes of separating the configure products and
# object files of one architecture from another.
HOST            := $(shell cat config.sys_type)
else
HOST            := unknown-generic
endif

# --- Important directories for source code and build products ---

SRC_DIR         := src
CONFIG_DIR      := config
OBJ_DIR         := obj
LIB_DIR         := lib
INC_DIR         := include

# Use the system type to name the config, object, and library directories.
# These directories are special in that they will contain products specific
# to this particular architecture.
BASE_CONFIG_PATH := ./$(CONFIG_DIR)/$(HOST)
BASE_OBJ_PATH    := ./$(OBJ_DIR)/$(HOST)/$(SRC_DIR)
BASE_LIB_PATH    := ./$(LIB_DIR)/$(HOST)
BASE_INC_PATH    := ./$(INC_DIR)/$(HOST)

# Pathname to the makefile fragment containing lots of various definitions,
# most of which were substituted via configure.
CONFIG_MK_FILE   := $(BASE_CONFIG_PATH)/config.mk

# Include the definitions in the config makefile fragment.
-include $(CONFIG_MK_FILE)

# Detect whether we actually got the config makefile fragment. If we didn't,
# then it is likely that the user has not yet generated it (via configure).
ifeq ($(strip $(CONFIG_MK_INCLUDED)),yes)
CONFIG_MK_PRESENT := yes
IS_CONFIGURED     := yes
else
CONFIG_MK_PRESENT := no
IS_CONFIGURED     := no
endif



#
# --- Library name and local paths ---------------------------------------------
#

# --- Shared library extension ---

SHLIB_EXT            := so

# --- Library names ---

LIBFLAME             := libflame

LIBFLAME_A           := $(LIBFLAME).a
LIBFLAME_SO          := $(LIBFLAME).$(SHLIB_EXT)

# --- Library filepaths ---

# Append the base library path to the library names.
LIBFLAME_A_PATH      := $(BASE_LIB_PATH)/$(LIBFLAME_A)
LIBFLAME_SO_PATH     := $(BASE_LIB_PATH)/$(LIBFLAME_SO)

LIBFLAME_SO_MAJ_EXT  := $(SHLIB_EXT).$(SO_MAJOR)
LIBFLAME_SO_MMB_EXT  := $(SHLIB_EXT).$(SO_MMB)

LIBFLAME_SONAME      := $(LIBFLAME).$(LIBFLAME_SO_MAJ_EXT)
LIBFLAME_SO_MAJ_PATH := $(BASE_LIB_PATH)/$(LIBFLAME_SONAME)

# Construct the output path when building a shared library.
LIBFLAME_SO_OUTPUT_NAME := $(LIBFLAME_SO_PATH)



#
# --- Shared library flags ----------------------------------------------------
#

# Specify the shared library's 'soname' field.
# NOTE: The flag for creating shared objects is different for Linux and OS X.
SOFLAGS    := -shared
SOFLAGS    += -Wl,-soname,$(LIBFLAME_SONAME)



#
# --- Main target variable definitions ----------------------------------------
#

MK_BASE_FLAMEC_SRC                    :=
MK_BASE_FLAMEC_OBJS                   :=

MK_BLAS_FLAMEC_SRC                    :=
MK_BLAS_FLAMEC_OBJS                   :=

MK_LAPACK_FLAMEC_SRC                  :=
MK_LAPACK_FLAMEC_OBJS                 :=


MK_MAP_LAPACK2FLAMEC_SRC              :=
MK_MAP_LAPACK2FLAMEC_OBJS             :=

MK_MAP_LAPACK2FLAMEC_F2C_SRC          :=
MK_MAP_LAPACK2FLAMEC_F2C_OBJS         :=

MK_MAP_LAPACK2FLAMEC_F2C_FLAMEC_SRC   :=
MK_MAP_LAPACK2FLAMEC_F2C_FLAMEC_OBJS  :=

MK_MAP_LAPACK2FLAMEC_F2C_INSTALL_SRC  :=
MK_MAP_LAPACK2FLAMEC_F2C_INSTALL_OBJS :=

MK_FLABLAS_F2C_SRC                    :=
MK_FLABLAS_F2C_OBJS                   :=

# --- Define install target names for static libraries ---

LIBFLAME_A_INST       := $(INSTALL_LIBDIR)/$(LIBFLAME_A)

# --- Define install target names for dynamic libraries ---

LIBFLAME_SO_INST      := $(INSTALL_LIBDIR)/$(LIBFLAME_SO)
LIBFLAME_SO_MAJ_INST  := $(INSTALL_LIBDIR)/$(LIBFLAME_SONAME)
LIBFLAME_SO_MMB_INST  := $(INSTALL_LIBDIR)/$(LIBFLAME).$(LIBFLAME_SO_MMB_EXT)

# --- Determine which libraries to build ---

MK_LIBS                   :=
MK_LIBS_INST              :=
MK_LIBS_SYML              :=

ifeq ($(FLA_ENABLE_STATIC_BUILD),yes)
MK_LIBS                   += $(LIBFLAME_A_PATH)
MK_LIBS_INST              += $(LIBFLAME_A_INST)
MK_LIBS_SYML              +=
endif

ifeq ($(FLA_ENABLE_DYNAMIC_BUILD),yes)
MK_LIBS                   += $(LIBFLAME_SO_PATH) \
                             $(LIBFLAME_SO_MAJ_PATH)
MK_LIBS_INST              += $(LIBFLAME_SO_MMB_INST)
MK_LIBS_SYML              += $(LIBFLAME_SO_INST) \
                             $(LIBFLAME_SO_MAJ_INST)
endif

# Strip leading, internal, and trailing whitespace.
MK_LIBS_INST              := $(strip $(MK_LIBS_INST))
MK_LIBS_SYML              := $(strip $(MK_LIBS_SYML))

# Set the path to the subdirectory of the include installation directory.
MK_INCL_DIR_INST          := $(INSTALL_INCDIR)



#
# --- Test definitions --------------------------------------------------------
#





#
# --- Include sub-tree makefile fragments --------------------------------------
#

# Makefile fragment name.
FRAGMENT_MK     := .fragment.mk

# Initialize our list of directory paths to makefile fragments with the empty list.
FRAGMENT_DIR_PATHS :=

# The only fragment subdirectory that we build from the top-level directory is the
# source directory.
SRC_PATH        := $(DIST_PATH)/$(SRC_DIR)
SRC_FRAG_PATH   := ./$(OBJ_DIR)/$(HOST)/$(SRC_DIR)

# These variables are used by the include statements as they recursively include
# one another. We initialize them to the distribution path and the base object
# path.
PARENT_SRC_PATH := $(DIST_PATH)
PARENT_PATH     := ./$(OBJ_DIR)/$(HOST)

# Recursively include all the makefile fragments.
#-include $(addsuffix /$(FRAGMENT_MK), $(FRAGMENT_SUB_DIRS))
-include $(addsuffix /$(FRAGMENT_MK), $(SRC_FRAG_PATH))

# Create a list of the makefile fragments.
MAKEFILE_FRAGMENTS := $(addsuffix /$(FRAGMENT_MK), $(FRAGMENT_DIR_PATHS))


# Detect whether we actually got any makefile fragments. If we didn't, then it
# is likely that the user has not yet generated them (via configure).
ifeq ($(strip $(MAKEFILE_FRAGMENTS)),)
MAKEFILE_FRAGMENTS_PRESENT := no
else
MAKEFILE_FRAGMENTS_PRESENT := yes
endif



#
# --- Compiler include path definitions ----------------------------------------
#

# A script (originating from BLIS) that creates a monolithic header file from
# many header files that are recursively #included from one another.
BUILD_PATH := $(DIST_PATH)/build
FLATTEN_H  := $(PYTHON) $(BUILD_PATH)/flatten-headers.py

# The path to the main header files.
FLAF2C_H_SRC_PATH := $(DIST_PATH)/src/base/flamec/include/FLA_f2c.h
FLAME_H_SRC_PATH  := $(DIST_PATH)/src/base/flamec/include/FLAME.h
BLIS1_H_SRC_PATH  := $(DIST_PATH)/src/base/flamec/blis/include/blis1.h

# Construct the path to what will be the intermediate flattened/monolithic
# header files.
FLAME_H       := FLAME.h
FLAME_H_FLAT  := $(BASE_INC_PATH)/$(FLAME_H)

BLIS1_H       := blis1.h
BLIS1_H_FLAT  := $(BASE_INC_PATH)/$(BLIS1_H)

FLAF2C_H      := FLA_f2c.h
FLAF2C_H_FLAT := $(BASE_INC_PATH)/$(FLAF2C_H)

# Expand the fragment paths that contain .h files to attain the set of header
# files present in all fragment paths.
MK_HEADER_FILES := $(foreach frag_path, $(FRAGMENT_DIR_PATHS), $(wildcard $(frag_path)/*.h))
MK_HEADER_FILES += $(BASE_CONFIG_PATH)/FLA_config.h

# Strip the leading, internal, and trailing whitespace from our list of header
# files. This makes the "make install-headers" much more readable.
MK_HEADER_FILES := $(strip $(MK_HEADER_FILES))

# Expand the fragment paths that contain .h files, and take the first expansion.
# Then, strip the header filename to leave the path to each header location.
# Notice this process even weeds out duplicates! Add the config directory manually
# since it contains FLA_config.h.
MK_HEADER_DIR_PATHS := $(dir $(foreach frag_path, $(FRAGMENT_DIR_PATHS), \
                                       $(firstword $(wildcard $(frag_path)/*.h))))
MK_HEADER_DIR_PATHS += $(BASE_CONFIG_PATH)

# Define a list of headers to flatten. We have to flatten blis1.h and FLA_f2c.h
# because a few files #include only those files, but they aren't needed after
# libflame is compiled.
HEADERS_TO_FLATTEN := $(FLAME_H_FLAT) $(BLIS1_H_FLAT) $(FLAF2C_H_FLAT)

# Define a list of headers to install and their installation path. The default
# is to only install FLAME.h.
HEADERS_TO_INSTALL := $(FLAME_H_FLAT)
HEADERS_INST       := $(addprefix $(MK_INCL_DIR_INST)/, $(notdir $(HEADERS_TO_INSTALL)))

# Add -I to each header path so we can specify our include search paths to the
# C and Fortran compilers. NOTE: This is primarily for access to the monolithic
# (flattened) FLAME.h file, athough a few other files are placed there too (see
# above).
#INCLUDE_PATHS   := $(strip $(patsubst %, -I%, $(MK_HEADER_DIR_PATHS)))
INCLUDE_PATHS   := $(strip $(patsubst %, -I%, $(BASE_INC_PATH)))

# When lapack2flame is enabled, we need to add a -I option for the directory
# in which the lapack2flame headers reside.
ifeq ($(FLA_ENABLE_LAPACK2FLAME),yes)
L2F_FRAG_DIR_PATHS   := $(filter $(DIST_PATH)/src/map/lapack2flamec%,$(FRAGMENT_DIR_PATHS))
L2F_HEADER_DIR_PATHS := $(dir $(foreach frag_path, $(L2F_FRAG_DIR_PATHS), \
                                       $(firstword $(wildcard $(frag_path)/*.h))))
INCLUDE_PATHS   += $(strip $(patsubst %, -I%, $(L2F_HEADER_DIR_PATHS)))
endif

# Add the include flags determined above to various compiler flags variables.
CFLAGS          := $(CFLAGS) $(INCLUDE_PATHS)
CFLAGS_NOOPT    := $(CFLAGS_NOOPT) $(INCLUDE_PATHS)
CPPFLAGS        := $(CPPFLAGS) $(INCLUDE_PATHS)
FFLAGS          := $(FFLAGS) $(INCLUDE_PATHS)



#
# --- Library object definitions -----------------------------------------------
#

# Convert source file paths to object file paths by replaying the base source
# directory with the base object directory, and also replacing the source file
# suffix (ie: '.c' or '.f') with '.o'.

MK_FLABLAS_F2C_OBJS                   := $(patsubst $(SRC_PATH)/%.c, $(BASE_OBJ_PATH)/%.o, \
                                                    $(filter %.c, $(MK_FLABLAS_F2C_SRC)))

MK_BASE_FLAMEC_OBJS                   := $(patsubst $(SRC_PATH)/%.c, $(BASE_OBJ_PATH)/%.o, \
                                                    $(filter %.c, $(MK_BASE_FLAMEC_SRC)))

MK_BLAS_FLAMEC_OBJS                   := $(patsubst $(SRC_PATH)/%.c, $(BASE_OBJ_PATH)/%.o, \
                                                    $(filter %.c, $(MK_BLAS_FLAMEC_SRC)))

MK_LAPACK_FLAMEC_OBJS                 := $(patsubst $(SRC_PATH)/%.c, $(BASE_OBJ_PATH)/%.o, \
                                                    $(filter %.c, $(MK_LAPACK_FLAMEC_SRC)))

MK_MAP_LAPACK2FLAMEC_OBJS             := $(patsubst $(SRC_PATH)/%.c, $(BASE_OBJ_PATH)/%.o, \
                                                    $(filter %.c, $(MK_MAP_LAPACK2FLAMEC_SRC)))

MK_MAP_LAPACK2FLAMEC_F2C_OBJS         := $(patsubst $(SRC_PATH)/%.c, $(BASE_OBJ_PATH)/%.o, \
                                                    $(filter %.c, $(MK_MAP_LAPACK2FLAMEC_F2C_SRC)))

MK_MAP_LAPACK2FLAMEC_F2C_FLAMEC_OBJS  := $(patsubst $(SRC_PATH)/%.c, $(BASE_OBJ_PATH)/%.o, \
                                                    $(filter %.c, $(MK_MAP_LAPACK2FLAMEC_F2C_FLAMEC_SRC)))

MK_MAP_LAPACK2FLAMEC_F2C_INSTALL_OBJS := $(patsubst $(SRC_PATH)/%.c, $(BASE_OBJ_PATH)/%.o, \

=== test/Makefile ===


#
# Makefile
#
# Field G. Van Zee
# 
# Makefile for libflame test suite driver.
#



#
# --- Include libflame config makefile fragment --------------------------------
#

# Determine the path to the libflame config makefile fragment. We'll use
# several variables defined there.
BUILD_DIR       := ../build
CONFIG_DIR      := ../config
LIB_DIR         := ../lib
INCLUDE_DIR     := ../include
HOST            := $(shell sh $(BUILD_DIR)/ac-utils/config.guess)
CONFIG_MK_FILE  := $(CONFIG_DIR)/$(HOST)/config.mk
LIB_PATH        := $(LIB_DIR)/$(HOST)/
INC_PATH        := $(INCLUDE_DIR)/$(HOST)/

# Include the definitions in the config makefile fragment.
-include $(CONFIG_MK_FILE)



#
# --- Optional overrides -------------------------------------------------------
#

# Uncomment and modify these definitions if you wish to override the values
# present in the master config makefile fragment.
# CC             := gcc
# LINKER         := $(CC)
# CFLAGS         := -g -O2 -Wall -Wno-comment
# LDFLAGS        := 
# INSTALL_PREFIX := $(HOME)/flame



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLAS implementation path. A BLAS library must be given in order to run
# the libflame test suite. Modify these definitions if needed.
LIBBLAS_PATH   := $(INSTALL_LIBDIR)
#LIBBLAS        := $(LIBBLAS_PATH)/libblas.a
LIBBLAS        := $(LIBBLAS_PATH)/libopenblas.a
#LIBBLAS        := $(HOME)/blis/lib/libblis.a

# LAPACK implementation path. These values only matter if libflame was
# configured with the external-lapack-interfaces option enabled. Modify
# these definitions if needed.
LIBLAPACK_PATH := $(INSTALL_LIBDIR)
LIBLAPACK      := $(LIBLAPACK_PATH)/liblapack.a



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := src
TEST_OBJ_PATH  := obj

#FLA_LIB_PATH   := $(INSTALL_PREFIX)/lib
#FLA_INC_PATH   := $(INSTALL_PREFIX)/include
FLA_LIB_PATH   := $(LIB_PATH)
FLA_INC_PATH   := $(INC_PATH)
LIBFLAME       := $(FLA_LIB_PATH)/libflame.a
#LIBFLAME       := $(FLA_LIB_PATH)/libflame.so

CFLAGS         += -I$(FLA_INC_PATH) -I$(TEST_SRC_PATH)

FNAME          := libflame

TEST_OBJS      := $(patsubst $(TEST_SRC_PATH)/%.c, \
                             $(TEST_OBJ_PATH)/%.o, \
                             $(wildcard $(TEST_SRC_PATH)/*.c))
TEST_BIN       := test_$(FNAME).x

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c
	$(CC) $(CFLAGS) -c $< -o $@

test_$(FNAME): $(TEST_OBJS)
	$(LINKER) $(TEST_OBJS) $(LIBFLAME) $(LIBLAPACK) $(LIBBLAS) $(LDFLAGS) -o $(TEST_BIN)

clean:
	$(RM_F) $(TEST_OBJS) $(TEST_BIN)

=== windows/Makefile ===



#
# --- Include variables determined at configure-time --------------------------
#
CONFIGURE_DEFS = config\config.mk

!if exist ( $(CONFIGURE_DEFS) )
!include $(CONFIGURE_DEFS)
!else
!error nmake: $(CONFIGURE_DEFS) does not exist! Run configure.cmd first.
!endif



#
# --- Include environment- and build-specific definitions ----------------------
#

MAKE_DEFS = build\defs.mk

# Include build definitions
!if exist ( $(MAKE_DEFS) )
!include $(MAKE_DEFS)
!else
!error nmake: $(MAKE_DEFS) does not exist! Your libflame distribution may be incomplete.
!endif



#
# --- Variable modifications ---------------------------------------------------
#

LIBFLAME_OBJS = $(FLAMEC_OBJS) $(LAPACK2FLAMEC_OBJS)



#
# --- High-level rules ---------------------------------------------------------
#

all: libflame

libflame: libflame-lib

libflame-objs: $(LIBFLAME_OBJS)

libflame-lib: $(LIB_LIBFLAME_DIRPATH)\$(LIBFLAME_LIB)

libflame-dll: $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME_DLL)

lib: libflame-lib

dll: libflame-dll

install: install-lib install-headers

install-lib: $(INSTALL_PREFIX_LIB)\$(LIBFLAME).lib

install-dll: $(INSTALL_PREFIX_DLL)\$(LIBFLAME).dll \
             $(INSTALL_PREFIX_DLL)\$(LIBFLAME).lib \
             $(INSTALL_PREFIX_DLL)\$(LIBFLAME).exp

install-headers: $(INSTALL_PREFIX_INC)\$(FLAME_H)

clean: clean-build clean-log

distclean: clean-config clean-build clean-log



#
# --- Source code (inference) rules --------------------------------------------
#

# --- C source files in flamec directory ---
{$(SRC_FLA_DIRPATH)}.c{$(OBJ_FLA_DIRPATH)}.obj:
!ifdef VERBOSE
	if not exist $(OBJ_FLA_DIRPATH) \
	   ( $(MKDIR) $(OBJ_FLA_DIRPATH) )
	$(CC) $(CFLAGS) /c $< /Fo$@
!else
	@if not exist $(OBJ_FLA_DIRPATH) \
	 (  ( $(ECHO) nmake: Creating $(OBJ_FLA_DIRPATH) directory ) & \
	    ( $(MKDIR) $(OBJ_FLA_DIRPATH) ) )
	@$(ECHO) nmake: Compiling $<
	@$(CC) $(CFLAGS) /c $< /Fo$@ >> $(CC_LOG_FILE)
!endif

# --- C source files in lapack2flamec directory ---
{$(SRC_L2F_DIRPATH)}.c{$(OBJ_L2F_DIRPATH)}.obj:
!ifdef VERBOSE
	if not exist $(OBJ_L2F_DIRPATH) \
	   ( $(MKDIR) $(OBJ_L2F_DIRPATH) )
	$(CC) $(CFLAGS) /c $< /Fo$@
!else
	@if not exist $(OBJ_L2F_DIRPATH) \
	 (  ( $(ECHO) nmake: Creating $(OBJ_L2F_DIRPATH) directory ) & \
	    ( $(MKDIR) $(OBJ_L2F_DIRPATH) ) )
	@$(ECHO) nmake: Compiling $<
	@$(CC) $(CFLAGS) /c $< /Fo$@ >> $(CC_LOG_FILE)
!endif



#
# --- Library generation rules -------------------------------------------------
#

# --- Static library ---
$(LIB_LIBFLAME_DIRPATH)\$(LIBFLAME_LIB): libflame-objs
!ifdef VERBOSE
	if not exist $(LIB_LIBFLAME_DIRPATH) \
	   ( $(MKDIR) $(LIB_LIBFLAME_DIRPATH) )
	$(COPY) $(OBJ_FLA_DIRPATH)\*.obj $(LIB_LIBFLAME_DIRPATH)
	$(COPY) $(OBJ_L2F_DIRPATH)\*.obj $(LIB_LIBFLAME_DIRPATH)
	$(CD) $(LIB_LIBFLAME_DIRPATH)
	$(LIB) $(LIB_OPTIONS) $(LIB_FLA_OUTPUT_ARG) $(LIB_FLA_INPUT_ARGS)
	$(DEL) *.obj
	$(CD) $(TOP_BUILD_DIR_ABS)
!else
	@if not exist $(LIB_LIBFLAME_DIRPATH) \
	 (  ( $(ECHO) nmake: Creating $(LIB_LIBFLAME_DIRPATH) directory ) & \
	    ( $(MKDIR) $(LIB_LIBFLAME_DIRPATH) ) )
	@$(ECHO) nmake: Creating static library $@
	@$(COPY) $(OBJ_FLA_DIRPATH)\*.obj $(LIB_LIBFLAME_DIRPATH) >> $(COPY_LOG_FILE)
	@$(COPY) $(OBJ_L2F_DIRPATH)\*.obj $(LIB_LIBFLAME_DIRPATH) >> $(COPY_LOG_FILE)
	@$(CD) $(LIB_LIBFLAME_DIRPATH)
	@$(LIB) $(LIB_OPTIONS) $(LIB_FLA_OUTPUT_ARG) $(LIB_FLA_INPUT_ARGS)
	@$(DEL) *.obj
	@$(CD) $(TOP_BUILD_DIR_ABS)
!endif

# --- Dynamic library (object code file, import library, and export file) ---
$(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME_DLL): libflame-objs
!ifdef VERBOSE
	if not exist $(DLL_LIBFLAME_DIRPATH) \
	   ( $(MKDIR) $(DLL_LIBFLAME_DIRPATH) )
	$(COPY) $(OBJ_FLA_DIRPATH)\*.obj $(DLL_LIBFLAME_DIRPATH) >> $(COPY_LOG_FILE)
	$(COPY) $(OBJ_L2F_DIRPATH)\*.obj $(DLL_LIBFLAME_DIRPATH) >> $(COPY_LOG_FILE)
	$(CD) $(DLL_LIBFLAME_DIRPATH)
	$(DIR) /B *.obj > $(OBJ_LIST_FILE)
	$(GENDLL) $(LIBFLAME) $(LIBFLAME) $(CC) $(LINKARGS_FILEPATH) $(SYM_DEF_FILEPATH) /objlist $(OBJ_LIST_FILE)
	$(DEL) $(OBJ_LIST_FILE)
	$(DEL) *.obj
	$(CD) $(TOP_BUILD_DIR_ABS)
!else
	@if not exist $(DLL_LIBFLAME_DIRPATH) \
	 (  ( $(ECHO) nmake: Creating $(DLL_LIBFLAME_DIRPATH) directory ) & \
	    ( $(MKDIR) $(DLL_LIBFLAME_DIRPATH) ) )
	@$(ECHO) nmake: Creating dynamic library $@
	@$(COPY) $(OBJ_FLA_DIRPATH)\*.obj $(DLL_LIBFLAME_DIRPATH) >> $(COPY_LOG_FILE)
	@$(COPY) $(OBJ_L2F_DIRPATH)\*.obj $(DLL_LIBFLAME_DIRPATH) >> $(COPY_LOG_FILE)
	@$(CD) $(DLL_LIBFLAME_DIRPATH)
	@$(DIR) /B *.obj > $(OBJ_LIST_FILE)
	@$(GENDLL) $(LIBFLAME) $(LIBFLAME) $(CC) $(LINKARGS_FILEPATH) $(SYM_DEF_FILEPATH) /objlist $(OBJ_LIST_FILE)
	@$(DEL) $(OBJ_LIST_FILE)
	@$(DEL) *.obj
	@$(CD) $(TOP_BUILD_DIR_ABS)
!endif



#
# --- Install rules ------------------------------------------------------------
#

# --- Header files ---
$(INSTALL_PREFIX_INC)\$(FLAME_H): $(INC_FLA_DIRPATH)\$(FLAME_H) \
                                  $(BUILD_DIRNAME)\$(FLA_CONFIG_H)
!ifdef VERBOSE
	if not exist $(INSTALL_PREFIX_INC) \
	   ( $(MKDIR) $(INSTALL_PREFIX_INC) )
    $(COPY) $(BUILD_DIRNAME)\$(FLA_CONFIG_H) $(INSTALL_PREFIX_INC) >> $(COPY_LOG_FILE)
    $(COPY) $(INC_FLA_DIRPATH)\*.h $(INSTALL_PREFIX_INC) >> $(COPY_LOG_FILE)
!else
	@if not exist $(INSTALL_PREFIX_INC) \
	    ( $(MKDIR) $(INSTALL_PREFIX_INC) )
    @$(ECHO) nmake: Installing libflame header files to $(INSTALL_PREFIX_INC)
    @$(COPY) $(BUILD_DIRNAME)\$(FLA_CONFIG_H) $(INSTALL_PREFIX_INC) >> $(COPY_LOG_FILE)
    @$(COPY) $(INC_FLA_DIRPATH)\*.h $(INSTALL_PREFIX_INC) >> $(COPY_LOG_FILE)
!endif

# --- Static library ---
$(INSTALL_PREFIX_LIB)\$(LIBFLAME).lib: $(LIB_LIBFLAME_DIRPATH)\$(LIBFLAME).lib
!ifdef VERBOSE
	if not exist $(INSTALL_PREFIX_LIB) ( $(MKDIR) $(INSTALL_PREFIX_LIB) )
	if     exist $(LIB_LIBFLAME_DIRPATH)\$(LIBFLAME).lib \
	   ( $(COPY) $(LIB_LIBFLAME_DIRPATH)\$(LIBFLAME).lib $(INSTALL_PREFIX_LIB) >> $(COPY_LOG_FILE) )
!else
	@if not exist $(INSTALL_PREFIX_LIB) ( $(MKDIR) $(INSTALL_PREFIX_LIB) )
	@if     exist $(LIB_LIBFLAME_DIRPATH)\$(LIBFLAME).lib \
	 (  ( $(ECHO) nmake: Installing $(LIB_LIBFLAME_DIRPATH)\$(LIBFLAME).lib to $(INSTALL_PREFIX_LIB) ) & \
	    ( $(COPY) $(LIB_LIBFLAME_DIRPATH)\$(LIBFLAME).lib $(INSTALL_PREFIX_LIB) >> $(COPY_LOG_FILE) ) )
!endif

# --- Dynamic library (object code) ---
$(INSTALL_PREFIX_DLL)\$(LIBFLAME).dll: $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).dll
!ifdef VERBOSE
	if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	if     exist $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).dll \
	   ( $(COPY) $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).dll $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) )
!else
	@if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	@if     exist $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).dll \
	 (  ( $(ECHO) nmake: Installing $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).dll to $(INSTALL_PREFIX_DLL) ) & \
	    ( $(COPY) $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).dll $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) ) )
!endif

# --- Dynamic library (import library) ---
$(INSTALL_PREFIX_DLL)\$(LIBFLAME).lib: $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).lib
!ifdef VERBOSE
	if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	if     exist $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).lib \
	   ( $(COPY) $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).lib $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) )
!else
	@if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	@if     exist $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).lib \
	 (  ( $(ECHO) nmake: Installing $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).lib to $(INSTALL_PREFIX_DLL) ) & \
	    ( $(COPY) $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).lib $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) ) )
!endif

# --- Dynamic library (export file) ---
$(INSTALL_PREFIX_DLL)\$(LIBFLAME).exp: $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).exp
!ifdef VERBOSE
	if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	if     exist $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).exp \
	   ( $(COPY) $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).exp $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) )
!else
	@if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	@if     exist $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).exp \
	 (  ( $(ECHO) nmake: Installing $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).exp to $(INSTALL_PREFIX_DLL) ) & \
	    ( $(COPY) $(DLL_LIBFLAME_DIRPATH)\$(LIBFLAME).exp $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) ) )
!endif



#
# --- Clean rules --------------------------------------------------------------
#

clean-log:
!ifdef VERBOSE
	if exist $(CC_LOG_FILE) \
	   ( $(DEL) $(CC_LOG_FILE) )
	if exist $(FC_LOG_FILE) \
	   ( $(DEL) $(FC_LOG_FILE) )
	if exist $(COPY_LOG_FILE) \
	   ( $(DEL) $(COPY_LOG_FILE) )
!else
	@if exist $(CC_LOG_FILE) \
	 (  ( $(ECHO) nmake: Deleting $(CC_LOG_FILE) ) & \
	    ( $(DEL) $(CC_LOG_FILE) ) )
	@if exist $(FC_LOG_FILE) \
	 (  ( $(ECHO) nmake: Deleting $(FC_LOG_FILE) ) & \
	    ( $(DEL) $(FC_LOG_FILE) ) )
	@if exist $(COPY_LOG_FILE) \
	 (  ( $(ECHO) nmake: Deleting $(COPY_LOG_FILE) ) & \
	    ( $(DEL) $(COPY_LOG_FILE) ) )
!endif

clean-config:
!ifdef VERBOSE
	if exist $(CNF_DIRNAME) \
	   ( $(RMDIR) $(CNF_DIRNAME) )
	if exist $(INC_DIRNAME) \
	   ( $(RMDIR) $(INC_DIRNAME) )
	if exist $(SRC_DIRNAME) \
	   ( $(RMDIR) $(SRC_DIRNAME) )
!else
	@if exist $(CNF_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(CNF_DIRNAME) directory ) & \
	    ( $(RMDIR) $(CNF_DIRNAME) ) )
	@if exist $(INC_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(INC_DIRNAME) directory ) & \
	    ( $(RMDIR) $(INC_DIRNAME) ) )
	@if exist $(SRC_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(SRC_DIRNAME) directory ) & \
	    ( $(RMDIR) $(SRC_DIRNAME) ) )
!endif

clean-build:
!ifdef VERBOSE
	if exist $(OBJ_DIRNAME) \
	   ( $(RMDIR) $(OBJ_DIRNAME) )
	if exist $(LIB_DIRNAME) \
	   ( $(RMDIR) $(LIB_DIRNAME) )
	if exist $(DLL_DIRNAME) \
	   ( $(RMDIR) $(DLL_DIRNAME) )
!else
	@if exist $(OBJ_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(OBJ_DIRNAME) directory ) & \
	    ( $(RMDIR) $(OBJ_DIRNAME) ) )
	@if exist $(LIB_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(LIB_DIRNAME) directory ) & \
	    ( $(RMDIR) $(LIB_DIRNAME) ) )
	@if exist $(DLL_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(DLL_DIRNAME) directory ) & \
	    ( $(RMDIR) $(DLL_DIRNAME) ) )
!endif

# Useful for developing when all we want to do is remove the library products.
clean-lib:
!ifdef VERBOSE
	if exist $(LIB_DIRNAME) \
	   ( $(RMDIR) $(LIB_DIRNAME) )
	if exist $(DLL_DIRNAME) \
	   ( $(RMDIR) $(DLL_DIRNAME) )
!else
	@if exist $(LIB_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(LIB_DIRNAME) directory ) & \
	    ( $(RMDIR) $(LIB_DIRNAME) ) )
	@if exist $(DLL_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(DLL_DIRNAME) directory ) & \
	    ( $(RMDIR) $(DLL_DIRNAME) ) )
!endif



#
# --- Help target --------------------------------------------------------------
#

help:
	@$(NMAKE_HELP)

=== test/windows/Makefile ===


#
# --- Include environment- and build-specific definitions ----------------------
#

CONFIG_MK = ..\..\windows\config\config.mk
DEFS_MK   = ..\..\windows\build\defs.mk

# Include build definitions
!if exist ( $(CONFIG_MK) )
!include $(CONFIG_MK)
!else
!error nmake: $(CONFIG_MK) does not exist! Run configure.cmd first.
!endif

# Include build definitions
!if exist ( $(DEFS_MK) )
!include $(DEFS_MK)
!else
!error nmake: $(DEFS_MK) does not exist! Your libflame distribution may be incomplete.
!endif



#
# --- General build definitions ------------------------------------------------
#

# Path to test suite source code.
SRC_PATH         = ..\src

# Path to directory where test suite object files will be stored.
OBJ_PATH         = obj

# Path to libflame and local headers.
LIBFLAME_HEADERS = $(INSTALL_PREFIX_INC)
LOCAL_HEADERS    = $(SRC_PATH)

# The installation paths for the static and dynamic libflame library builds.
LIB_LIBPATH      = $(INSTALL_PREFIX_LIB)
DLL_LIBPATH      = $(INSTALL_PREFIX_DLL)

# We have to reconstruct the C compiler flags with the new include paths.
CPPROCFLAGS      = /I$(LIBFLAME_HEADERS) /I$(LOCAL_HEADERS)
CFLAGS           = $(CMISCFLAGS) $(CLANGFLAGS) $(CPPROCFLAGS) $(CWARNFLAGS) \
                   $(CDBGFLAGS) $(COPTFLAGS) $(CRTIMEFLAGS) $(CMTHREADFLAGS)

# We use the C compiler as our linker.
LINKER           = $(CC)

# The linker flags. This might need to be modified depending on your build
# environment.
LDFLAGS          = /nologo /link \
                   /LIBPATH:"C:\Program Files\Microsoft SDKs\Windows\v6.0A\Lib" \
                   /LIBPATH:"C:\Program Files (x86)\Microsoft Visual Studio 9.0\VC\lib" \
                   /nodefaultlib:libcmt /nodefaultlib:libc /nodefaultlib:libmmt \
                   msvcrt.lib \
                   /LIBPATH:"C:\Program Files (x86)\Intel\Compiler\11.1\048\lib\ia32" \
                   /LIBPATH:"C:\Program Files (x86)\Intel\Compiler\11.1\048\mkl\ia32\lib" \
                   mkl_intel_c.lib \
                   mkl_sequential.lib \
                   mkl_core.lib

TEST_OBJS        = $(OBJ_PATH)\test_libflame.obj \
                   $(OBJ_PATH)\test_chol.obj \
                   $(OBJ_PATH)\test_lu_nopiv.obj \
                   $(OBJ_PATH)\test_lu_piv.obj \
                   $(OBJ_PATH)\test_lu_incpiv.obj \
                   $(OBJ_PATH)\test_qrut.obj \
                   $(OBJ_PATH)\test_qrutinc.obj \
                   $(OBJ_PATH)\test_lqut.obj \
                   $(OBJ_PATH)\test_uddateut.obj \
                   $(OBJ_PATH)\test_uddateutinc.obj \
                   $(OBJ_PATH)\test_apqudut.obj \
                   $(OBJ_PATH)\test_apqudutinc.obj \
                   $(OBJ_PATH)\test_hessut.obj \
                   $(OBJ_PATH)\test_tridiagut.obj \
                   $(OBJ_PATH)\test_bidiagut.obj \
                   $(OBJ_PATH)\test_trinv.obj \
                   $(OBJ_PATH)\test_spdinv.obj \
                   $(OBJ_PATH)\test_sylv.obj

# Binary path. We put it one directory up because that is where the input
# paremeter files reside.
TEST_BIN         = ..\test_libflame.exe

# The inference rule to compile source to object files.
{$(SRC_PATH)}.c{$(OBJ_PATH)}.obj:
	$(CC) $(CFLAGS) /c $< /Fo$@

# The rule to build the test suite driver by linking against a static
# build of libflame. This is the default.
with-lib: $(TEST_OBJS)
	$(LINKER) $(TEST_OBJS) /Fe$(TEST_BIN) $(LDFLAGS) $(LIB_LIBPATH)\$(LIBFLAME_LIB)

# The rule to build the test suite driver by linking against a dynamic
# build of libflame.
with-dll: $(TEST_OBJS)
	$(LINKER) $(TEST_OBJS) /Fe$(TEST_BIN) $(LDFLAGS) $(DLL_LIBPATH)\$(LIBFLAME_LIB)

clean:
	del /F /Q $(OBJ_PATH)\*.obj
	del /F /Q $(TEST_BIN)

=== docs/libflame/old/Makefile ===
pdf:
	dvipdf plapack2e.dvi plapack2e.pdf
	cp plapack2e.pdf ~/public_html/plapack2e.pdf

clean:
	rm *~; rm *.aux; rm *.idx; rm *.log; rm *.toc; rm */*~

=== netlib-test/lapack-3.4.2/INSTALL/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(TIMING Fortran)
add_executable(secondtst_NONE second_NONE.f secondtst.f)
add_executable(secondtst_EXT_ETIME second_EXT_ETIME.f secondtst.f)
add_executable(secondtst_EXT_ETIME_ second_EXT_ETIME_.f secondtst.f)
add_executable(secondtst_INT_ETIME second_INT_ETIME.f secondtst.f)
add_executable(secondtst_INT_CPU_TIME second_INT_CPU_TIME.f secondtst.f)
add_executable(testieee tstiee.f)
add_executable(testversion ilaver.f LAPACK_version.f)

=== netlib-test/lapack-3.4.2/TESTING/CMakeLists.txt ===
if(MSVC_VERSION)
#  string(REPLACE "/STACK:10000000" "/STACK:900000000000000000"
#    CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
  string(REGEX REPLACE "(.*)/STACK:(.*) (.*)" "\\1/STACK:900000000000000000 \\3"
    CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
endif()
add_subdirectory(MATGEN)
add_subdirectory(LIN)
add_subdirectory(EIG)
macro(add_lapack_test output input target)
  set(TEST_INPUT "${LAPACK_SOURCE_DIR}/TESTING/${input}")
  set(TEST_OUTPUT "${LAPACK_BINARY_DIR}/TESTING/${output}")
  get_target_property(TEST_LOC ${target} LOCATION)
  string(REPLACE "." "_" input_name ${input})
  set(testName "${target}_${input_name}")
  if(EXISTS "${TEST_INPUT}")
    add_test(LAPACK-${testName} "${CMAKE_COMMAND}"
      -DTEST=${TEST_LOC}
      -DINPUT=${TEST_INPUT} 
      -DOUTPUT=${TEST_OUTPUT} 
      -DINTDIR=${CMAKE_CFG_INTDIR}
      -P "${LAPACK_SOURCE_DIR}/TESTING/runtest.cmake")
  endif()
endmacro(add_lapack_test)

if (BUILD_SINGLE)
add_lapack_test(stest.out stest.in xlintsts)
#
# ======== SINGLE RFP LIN TESTS ========================
add_lapack_test(stest_rfp.out stest_rfp.in xlintstrfs)
#
#
# ======== SINGLE EIG TESTS ===========================
#

add_lapack_test(snep.out nep.in xeigtsts)


add_lapack_test(ssep.out sep.in xeigtsts)


add_lapack_test(ssvd.out svd.in xeigtsts)


add_lapack_test(sec.out sec.in xeigtsts)


add_lapack_test(sed.out sed.in xeigtsts)


add_lapack_test(sgg.out sgg.in xeigtsts)


add_lapack_test(sgd.out sgd.in xeigtsts)


add_lapack_test(ssb.out ssb.in xeigtsts)


add_lapack_test(ssg.out ssg.in xeigtsts)


add_lapack_test(sbal.out sbal.in xeigtsts)


add_lapack_test(sbak.out sbak.in xeigtsts)


add_lapack_test(sgbal.out sgbal.in xeigtsts)


add_lapack_test(sgbak.out sgbak.in xeigtsts)


add_lapack_test(sbb.out sbb.in xeigtsts)


add_lapack_test(sglm.out glm.in xeigtsts)


add_lapack_test(sgqr.out gqr.in xeigtsts)


add_lapack_test(sgsv.out gsv.in xeigtsts)


add_lapack_test(scsd.out csd.in xeigtsts)


add_lapack_test(slse.out lse.in xeigtsts)
endif()

if (BUILD_DOUBLE)
#
# ======== DOUBLE LIN TESTS ===========================
add_lapack_test(dtest.out dtest.in xlintstd)
#
# ======== DOUBLE RFP LIN TESTS ========================
add_lapack_test(dtest_rfp.out dtest_rfp.in xlintstrfd)
#
# ======== DOUBLE EIG TESTS ===========================

add_lapack_test(dnep.out nep.in xeigtstd)


add_lapack_test(dsep.out sep.in xeigtstd)


add_lapack_test(dsvd.out svd.in xeigtstd)


add_lapack_test(dec.out dec.in xeigtstd)


add_lapack_test(ded.out ded.in xeigtstd)


add_lapack_test(dgg.out dgg.in xeigtstd)


add_lapack_test(dgd.out dgd.in xeigtstd)


add_lapack_test(dsb.out dsb.in xeigtstd)


add_lapack_test(dsg.out dsg.in xeigtstd)


add_lapack_test(dbal.out dbal.in xeigtstd)


add_lapack_test(dbak.out dbak.in xeigtstd)


add_lapack_test(dgbal.out dgbal.in xeigtstd)


add_lapack_test(dgbak.out dgbak.in xeigtstd)


add_lapack_test(dbb.out dbb.in xeigtstd)


add_lapack_test(dglm.out glm.in xeigtstd)


add_lapack_test(dgqr.out gqr.in xeigtstd)


add_lapack_test(dgsv.out gsv.in xeigtstd)


add_lapack_test(dcsd.out csd.in xeigtstd)


add_lapack_test(dlse.out lse.in xeigtstd)
endif()

if (BUILD_COMPLEX)
add_lapack_test(ctest.out ctest.in xlintstc)
#
# ======== COMPLEX RFP LIN TESTS ========================
add_lapack_test(ctest_rfp.out ctest_rfp.in xlintstrfc)
#
# ======== COMPLEX EIG TESTS ===========================

add_lapack_test(cnep.out nep.in xeigtstc)


add_lapack_test(csep.out sep.in xeigtstc)


add_lapack_test(csvd.out svd.in xeigtstc)


add_lapack_test(cec.out cec.in xeigtstc)


add_lapack_test(ced.out ced.in xeigtstc)


add_lapack_test(cgg.out cgg.in xeigtstc)


add_lapack_test(cgd.out cgd.in xeigtstc)


add_lapack_test(csb.out csb.in xeigtstc)


add_lapack_test(csg.out csg.in xeigtstc)


add_lapack_test(cbal.out cbal.in xeigtstc)


add_lapack_test(cbak.out cbak.in xeigtstc)


add_lapack_test(cgbal.out cgbal.in xeigtstc)


add_lapack_test(cgbak.out cgbak.in xeigtstc)


add_lapack_test(cbb.out cbb.in xeigtstc)


add_lapack_test(cglm.out glm.in xeigtstc)


add_lapack_test(cgqr.out gqr.in xeigtstc)


add_lapack_test(cgsv.out gsv.in xeigtstc)


add_lapack_test(ccsd.out csd.in xeigtstc)


add_lapack_test(clse.out lse.in xeigtstc)
endif()

if (BUILD_COMPLEX16)
#
# ======== COMPLEX16 LIN TESTS ========================
add_lapack_test(ztest.out ztest.in xlintstz)
#
# ======== COMPLEX16 RFP LIN TESTS ========================
add_lapack_test(ztest_rfp.out ztest_rfp.in xlintstrfz)
#
# ======== COMPLEX16 EIG TESTS ===========================

add_lapack_test(znep.out nep.in xeigtstz)


add_lapack_test(zsep.out sep.in xeigtstz)


add_lapack_test(zsvd.out svd.in xeigtstz)


add_lapack_test(zec.out zec.in xeigtstz)


add_lapack_test(zed.out zed.in xeigtstz)


add_lapack_test(zgg.out zgg.in xeigtstz)


add_lapack_test(zgd.out zgd.in xeigtstz)


add_lapack_test(zsb.out zsb.in xeigtstz)


add_lapack_test(zsg.out zsg.in xeigtstz)


add_lapack_test(zbal.out zbal.in xeigtstz)


add_lapack_test(zbak.out zbak.in xeigtstz)


add_lapack_test(zgbal.out zgbal.in xeigtstz)


add_lapack_test(zgbak.out zgbak.in xeigtstz)


add_lapack_test(zbb.out zbb.in xeigtstz)


add_lapack_test(zglm.out glm.in xeigtstz)


add_lapack_test(zgqr.out gqr.in xeigtstz)


add_lapack_test(zgsv.out gsv.in xeigtstz)


add_lapack_test(zcsd.out csd.in xeigtstz)


add_lapack_test(zlse.out lse.in xeigtstz)
endif()


if (BUILD_SIMPLE)
    if (BUILD_DOUBLE)
#
# ======== SINGLE-DOUBLE PROTO LIN TESTS ==============
        add_lapack_test(dstest.out dstest.in xlintstds)
    endif()
endif()


if (BUILD_COMPLEX)
    if (BUILD_COMPLEX16)
#
# ======== COMPLEX-COMPLEX16 LIN TESTS ========================
        add_lapack_test(zctest.out zctest.in xlintstzc)
    endif()
endif()

# ==============================================================================

execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${LAPACK_SOURCE_DIR}/lapack_testing.py ${LAPACK_BINARY_DIR})
 add_test(
  NAME LAPACK_Test_Summary
  WORKING_DIRECTORY ${LAPACK_BINARY_DIR}
  COMMAND ${PYTHON_EXECUTABLE} "lapack_testing.py"
 )

=== old/lapack-test/3.4.2/Makefile ===
#######################################################################
#  This makefile runs the test programs for the linear equation routines
#  and the eigenvalue routines in LAPACK.  The test output files
#  are grouped as follows:
#
#       SLINTST,SEIGTST  -- Single precision real test routines
#       CLINTST,CEIGTST  -- Single precision complex test routines
#       DLINTST,DEIGTST  -- Double precision real test routines
#       ZLINTST,ZEIGTST  -- Double precision complex test routines
#
#  Test programs can be executed for all or some of the four different
#  precisions.  Enter 'make' followed by one or more of the data types
#  desired.
#  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments runs all eight test programs.
#  The executable files are called:
#       xlintsts, xlintstd, xlintstc, and xlintstz for LIN
#       xeigtsts, xeigtstd, xeigtstc, and xeigtstz for EIG
#  and exist in the current directory level.
#
#  To remove the output files after the tests have been run, enter
#       make clean
#
#  To re-run specific tests after a make, enter (for example):
#       'rm ssvd.out; make'  or:
#       'make ssvd.out' or:
#       'touch svd.in; make' (to re-run the single precision SVD tests.)
#
#       'rm *svd.out; make'  (to re-run all the SVD tests.)
#
#######################################################################

include ../make.inc

ifneq ($(strip $(VARLIB)),)
    LAPACKLIB :=  $(VARLIB) ../$(LAPACKLIB)
endif


all:     single complex double complex16 singleproto doubleproto complexproto complex16proto

SEIGTST= snep.out \
         ssep.out \
         ssvd.out \
         sec.out \
         sed.out \
         sgg.out \
         sgd.out \
         ssb.out \
	 ssg.out \
         sbal.out \
         sbak.out \
         sgbal.out \
         sgbak.out \
         sbb.out \
         sglm.out \
         sgqr.out \
         sgsv.out \
         scsd.out \
         slse.out

CEIGTST= cnep.out \
         csep.out \
         csvd.out \
         cec.out \
         ced.out \
         cgg.out \
         cgd.out \
         csb.out \
	 csg.out \
         cbal.out \
         cbak.out \
         cgbal.out \
         cgbak.out \
         cbb.out \
         cglm.out \
         cgqr.out \
         cgsv.out \
         ccsd.out \
         clse.out

DEIGTST= dnep.out \
         dsep.out \
         dsvd.out \
         dec.out \
         ded.out \
         dgg.out \
         dgd.out \
         dsb.out \
	 dsg.out \
         dbal.out \
         dbak.out \
         dgbal.out \
         dgbak.out \
         dbb.out \
         dglm.out \
         dgqr.out \
         dgsv.out \
         dcsd.out \
         dlse.out

ZEIGTST= znep.out \
         zsep.out \
         zsvd.out \
         zec.out \
         zed.out \
         zgg.out \
         zgd.out \
         zsb.out \
	 zsg.out \
         zbal.out \
         zbak.out \
         zgbal.out \
         zgbak.out \
         zbb.out \
         zglm.out \
         zgqr.out \
         zgsv.out \
         zcsd.out \
         zlse.out


SLINTST= stest.out

SLINTSTPROTO= stest_rfp.out

CLINTST= ctest.out

CLINTSTPROTO= ctest_rfp.out

DLINTST= dtest.out

DLINTSTPROTO= dstest.out dtest_rfp.out

ZLINTST= ztest.out

ZLINTSTPROTO= zctest.out ztest_rfp.out

single:         $(SLINTST) $(SEIGTST)
complex:        $(CLINTST) $(CEIGTST)
double:         $(DLINTST) $(DEIGTST)
complex16:      $(ZLINTST) $(ZEIGTST)
singleproto:    $(SLINTSTPROTO)
complexproto:   $(CLINTSTPROTO)
doubleproto:    $(DLINTSTPROTO)
complex16proto: $(ZLINTSTPROTO)

#
# ======== SINGLE LIN TESTS ===========================

stest.out: stest.in xlintsts
	@echo Testing REAL LAPACK linear equation routines
	./xlintsts < stest.in > $@ 2>&1
#
# ======== COMPLEX LIN TESTS ==========================

ctest.out: ctest.in xlintstc
	@echo Testing COMPLEX LAPACK linear equation routines
	./xlintstc < ctest.in > $@ 2>&1
#
# ======== DOUBLE LIN TESTS ===========================

dtest.out: dtest.in xlintstd
	@echo Testing DOUBLE PRECISION LAPACK linear equation routines
	./xlintstd < dtest.in > $@ 2>&1
#
# ======== COMPLEX16 LIN TESTS ========================

ztest.out: ztest.in xlintstz
	@echo Testing COMPLEX16 LAPACK linear equation routines
	./xlintstz < ztest.in > $@ 2>&1
#
# ======== SINGLE-DOUBLE PROTO LIN TESTS ==============

dstest.out: dstest.in xlintstds
	@echo Testing SINGLE-DOUBLE PRECISION LAPACK prototype linear equation routines
	./xlintstds < dstest.in > $@ 2>&1
#
# ======== COMPLEX-COMPLEX16 LIN TESTS ========================

zctest.out: zctest.in xlintstzc
	@echo Testing COMPLEX-COMPLEX16 LAPACK protoype linear equation routines
	./xlintstzc < zctest.in > $@ 2>&1
#
# ======== SINGLE RFP LIN TESTS ========================

stest_rfp.out: stest_rfp.in xlintstrfs
	@echo Testing REAL LAPACK RFP protoype linear equation routines
	./xlintstrfs < stest_rfp.in > $@ 2>&1
#
# ======== COMPLEX16 RFP LIN TESTS ========================

dtest_rfp.out: dtest_rfp.in xlintstrfd
	@echo Testing DOUBLE PRECISION LAPACK RFP protoype linear equation routines
	./xlintstrfd < dtest_rfp.in > $@ 2>&1
#
# ======== COMPLEX16 RFP LIN TESTS ========================

ctest_rfp.out: ctest_rfp.in xlintstrfc
	@echo Testing COMPLEX LAPACK RFP protoype linear equation routines
	./xlintstrfc < ctest_rfp.in > $@ 2>&1
#
# ======== COMPLEX16 RFP LIN TESTS ========================

ztest_rfp.out: ztest_rfp.in xlintstrfz
	@echo Testing COMPLEX16 LAPACK RFP protoype linear equation routines
	./xlintstrfz < ztest_rfp.in > $@ 2>&1
#
#
# ======== SINGLE EIG TESTS ===========================
#

snep.out: nep.in xeigtsts
	@echo NEP: Testing Nonsymmetric Eigenvalue Problem routines
	./xeigtsts < nep.in > $@ 2>&1

ssep.out: sep.in xeigtsts
	@echo SEP: Testing Symmetric Eigenvalue Problem routines
	./xeigtsts < sep.in > $@ 2>&1

ssvd.out: svd.in xeigtsts
	@echo SVD: Testing Singular Value Decomposition routines
	./xeigtsts < svd.in > $@ 2>&1

sec.out: sec.in xeigtsts
	@echo SEC: Testing REAL Eigen Condition Routines
	./xeigtsts < sec.in > $@ 2>&1

sed.out: sed.in xeigtsts
	@echo SEV: Testing REAL Nonsymmetric Eigenvalue Driver
	./xeigtsts < sed.in > $@ 2>&1

sgg.out: sgg.in xeigtsts
	@echo SGG: Testing REAL Nonsymmetric Generalized Eigenvalue Problem routines
	./xeigtsts < sgg.in > $@ 2>&1

sgd.out: sgd.in xeigtsts
	@echo SGD: Testing REAL Nonsymmetric Generalized Eigenvalue Problem driver routines
	./xeigtsts < sgd.in > $@ 2>&1

ssb.out: ssb.in xeigtsts
	@echo SSB: Testing REAL Symmetric Eigenvalue Problem routines
	./xeigtsts < ssb.in > $@ 2>&1

ssg.out: ssg.in xeigtsts
	@echo SSG: Testing REAL Symmetric Generalized Eigenvalue Problem routines
	./xeigtsts < ssg.in > $@ 2>&1

sbal.out: sbal.in xeigtsts
	@echo SGEBAL: Testing the balancing of a REAL general matrix
	./xeigtsts < sbal.in > $@ 2>&1

sbak.out: sbak.in xeigtsts
	@echo SGEBAK: Testing the back transformation of a REAL balanced matrix
	./xeigtsts < sbak.in > $@ 2>&1

sgbal.out: sgbal.in xeigtsts
	@echo SGGBAL: Testing the balancing of a pair of REAL general matrices
	./xeigtsts < sgbal.in > $@ 2>&1

sgbak.out: sgbak.in xeigtsts
	@echo SGGBAK: Testing the back transformation of a pair of REAL balanced matrices
	./xeigtsts < sgbak.in > $@ 2>&1

sbb.out: sbb.in xeigtsts
	@echo SBB:  Testing banded Singular Value Decomposition routines
	./xeigtsts < sbb.in > $@ 2>&1

sglm.out: glm.in xeigtsts
	@echo GLM: Testing Generalized Linear Regression Model routines
	./xeigtsts < glm.in > $@ 2>&1

sgqr.out: gqr.in xeigtsts
	@echo GQR: Testing Generalized QR and RQ factorization routines
	./xeigtsts < gqr.in > $@ 2>&1

sgsv.out: gsv.in xeigtsts
	@echo GSV: Testing Generalized Singular Value Decomposition routines
	./xeigtsts < gsv.in > $@ 2>&1

scsd.out: csd.in xeigtsts
	@echo CSD: Testing CS Decomposition routines
	./xeigtsts < csd.in > $@ 2>&1

slse.out: lse.in xeigtsts
	@echo LSE: Testing Constrained Linear Least Squares routines
	./xeigtsts < lse.in > $@ 2>&1
#
# ======== COMPLEX EIG TESTS ===========================

cnep.out: nep.in xeigtstc
	@echo NEP: Testing Nonsymmetric Eigenvalue Problem routines
	./xeigtstc < nep.in > $@ 2>&1

csep.out: sep.in xeigtstc
	@echo SEP: Testing Symmetric Eigenvalue Problem routines
	./xeigtstc < sep.in > $@ 2>&1

csvd.out: svd.in xeigtstc
	@echo SVD: Testing Singular Value Decomposition routines
	./xeigtstc < svd.in > $@ 2>&1

cec.out: cec.in xeigtstc
	@echo CEC: Testing COMPLEX Eigen Condition Routines
	./xeigtstc < cec.in > $@ 2>&1

ced.out: ced.in xeigtstc
	@echo CES: Testing COMPLEX Nonsymmetric Schur Form Driver
	./xeigtstc < ced.in > $@ 2>&1

cgg.out: cgg.in xeigtstc
	@echo CGG: Testing COMPLEX Nonsymmetric Generalized Eigenvalue Problem routines
	./xeigtstc < cgg.in > $@ 2>&1

cgd.out: cgd.in xeigtstc
	@echo CGD: Testing COMPLEX Nonsymmetric Generalized Eigenvalue Problem driver routines
	./xeigtstc < cgd.in > $@ 2>&1

csb.out: csb.in xeigtstc
	@echo CHB: Testing Hermitian Eigenvalue Problem routines
	./xeigtstc < csb.in > $@ 2>&1

csg.out: csg.in xeigtstc
	@echo CSG: Testing Symmetric Generalized Eigenvalue Problem routines
	./xeigtstc < csg.in > $@ 2>&1

cbal.out: cbal.in xeigtstc
	@echo CGEBAL: Testing the balancing of a COMPLEX general matrix
	./xeigtstc < cbal.in > $@ 2>&1

cbak.out: cbak.in xeigtstc
	@echo CGEBAK: Testing the back transformation of a COMPLEX balanced matrix
	./xeigtstc < cbak.in > $@ 2>&1

cgbal.out: cgbal.in xeigtstc
	@echo CGGBAL: Testing the balancing of a pair of COMPLEX general matrices
	./xeigtstc < cgbal.in > $@ 2>&1

cgbak.out: cgbak.in xeigtstc
	@echo CGGBAK: Testing the back transformation of a pair of COMPLEX balanced matrices
	./xeigtstc < cgbak.in > $@ 2>&1

cbb.out: cbb.in xeigtstc
	@echo CBB:  Testing banded Singular Value Decomposition routines
	./xeigtstc < cbb.in > $@ 2>&1

cglm.out: glm.in xeigtstc
	@echo GLM: Testing Generalized Linear Regression Model routines
	./xeigtstc < glm.in > $@ 2>&1

cgqr.out: gqr.in xeigtstc
	@echo GQR: Testing Generalized QR and RQ factorization routines
	./xeigtstc < gqr.in > $@ 2>&1

cgsv.out: gsv.in xeigtstc
	@echo GSV: Testing Generalized Singular Value Decomposition routines
	./xeigtstc < gsv.in > $@ 2>&1

ccsd.out: csd.in xeigtstc
	@echo CSD: Testing CS Decomposition routines
	./xeigtstc < csd.in > $@ 2>&1

clse.out: lse.in xeigtstc
	@echo LSE: Testing Constrained Linear Least Squares routines
	./xeigtstc < lse.in > $@ 2>&1
#
# ======== DOUBLE EIG TESTS ===========================

dnep.out: nep.in xeigtstd
	@echo NEP: Testing Nonsymmetric Eigenvalue Problem routines
	./xeigtstd < nep.in > $@ 2>&1

dsep.out: sep.in xeigtstd
	@echo SEP: Testing Symmetric Eigenvalue Problem routines
	./xeigtstd < sep.in > $@ 2>&1

dsvd.out: svd.in xeigtstd
	@echo SVD: Testing Singular Value Decomposition routines
	./xeigtstd < svd.in > $@ 2>&1

dec.out: dec.in xeigtstd
	@echo DEC: Testing DOUBLE PRECISION Eigen Condition Routines
	./xeigtstd < dec.in > $@ 2>&1

ded.out: ded.in xeigtstd
	@echo DEV: Testing DOUBLE PRECISION Nonsymmetric Eigenvalue Driver
	./xeigtstd < ded.in > $@ 2>&1

dgg.out: dgg.in xeigtstd
	@echo DGG: Testing DOUBLE PRECISION Nonsymmetric Generalized Eigenvalue Problem routines
	./xeigtstd < dgg.in > $@ 2>&1

dgd.out: dgd.in xeigtstd
	@echo DGD: Testing DOUBLE PRECISION Nonsymmetric Generalized Eigenvalue Problem driver routines
	./xeigtstd < dgd.in > $@ 2>&1

dsb.out: dsb.in xeigtstd
	@echo DSB: Testing DOUBLE PRECISION Symmetric Eigenvalue Problem routines
	./xeigtstd < dsb.in > $@ 2>&1

dsg.out: dsg.in xeigtstd
	@echo DSG: Testing DOUBLE PRECISION Symmetric Generalized Eigenvalue Problem routines
	./xeigtstd < dsg.in > $@ 2>&1

dbal.out: dbal.in xeigtstd
	@echo DGEBAL: Testing the balancing of a DOUBLE PRECISION general matrix
	./xeigtstd < dbal.in > $@ 2>&1

dbak.out: dbak.in xeigtstd
	@echo DGEBAK:  Testing the back transformation of a DOUBLE PRECISION balanced matrix
	./xeigtstd < dbak.in > $@ 2>&1

=== old/lapack-test/fla-timing/Makefile ===

#
# Makefile
#
# Field G. Van Zee
# 
# Makefile for libflame test suite driver.
#

#
# --- Include libflame config makefile fragment --------------------------------
#

# Determine the path to the libflame config makefile fragment. We'll use
# several variables defined there.
BUILD_DIRPATH       := ../../build
CONFIG_DIRPATH      := ../../config
HOST                := $(shell sh $(BUILD_DIRPATH)/ac-utils/config.guess)
CONFIG_MK_FRAGMENT  := $(CONFIG_DIRPATH)/$(HOST)/config.mk

# Include the definitions in the config makefile fragment.
-include $(CONFIG_MK_FRAGMENT)

#
# --- Optional overrides -------------------------------------------------------
#

# Uncomment and modify these definitions if you wish to override the values
# present in the master config makefile fragment.
# CC             := gcc
# LINKER         := $(CC)
# CFLAGS         := -g -O2 -Wall -Wno-comment
# LDFLAGS        := 
INSTALL_PREFIX := /Users/kyungjoo/Lib/FLAME



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLAS implementation path. A BLAS library must be given in order to run
# the libflame test suite. Modify these definitions if needed.
LIBBLAS        := -L/opt/local/lib -lcblas -lf77blas -latlas -lf2c 

# LAPACK implementation path. These values only matter if libflame was
# configured with the external-lapack-interfaces option enabled. Modify
# these definitions if needed.
LIBLAPACK      := -L/opt/local/lib -llapack

#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := src
TEST_OBJ_PATH  := obj

FLA_LIB_PATH   := ../../lib/$(HOST)
FLA_INC_PATH   := ../../include
LIBFLAME       := $(FLA_LIB_PATH)/libflame.a

CFLAGS         += -I$(FLA_INC_PATH) -I$(TEST_SRC_PATH)

FNAME          := lapack2flame

TEST_OBJS      := $(patsubst $(TEST_SRC_PATH)/%.c, \
                             $(TEST_OBJ_PATH)/%.o, \
                             $(wildcard $(TEST_SRC_PATH)/*.c))

TEST_BIN       := test_$(FNAME).x

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c
	$(CC) $(CFLAGS) -c $< -o $@

test_$(FNAME): $(TEST_OBJS)
	$(LINKER) $(TEST_OBJS) $(LDFLAGS) $(LIBFLAME) $(LIBLAPACK) $(LIBBLAS) -o $(TEST_BIN)

clean:
	$(RM_F) $(TEST_OBJS) $(TEST_BIN) *~

=== old/lapack-test/lapack-timing/Makefile ===
#######################################################################
#  This makefile runs the timing programs for the linear equation routines
#  and the eigenvalue routines in LAPACK.  The timing output files
#  are grouped as follows:
#
#       SLINTIM,SEIGTIM  -- Single precision real time routines
#       CLINTIM,CEIGTIM  -- Single precision complex time routines
#       DLINTIM,DEIGTIM  -- Double precision real time routines
#       ZLINTIM,ZEIGTIM  -- Double precision complex time routines
#
#  Timing programs can be executed for all or some of the four different
#  precisions.  Enter 'make' followed by one or more of the data types
#  desired.
#
#  By default, 'make' alone executes the timings with SMALL data sets.
#
#  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments runs all eight test programs with the SMALL
#  timing data files.
#
#  If you wish to use the LARGE data sets for your timings, you
#  need to type
#       make large
#  for all tests, which would be equivalent to typing
#       make single_large double_large complex_large complex16_large
#  which could also be executed separately, for example, as
#       make single_large
#
#  The executable files are called:
#       xlintims, xlintimd, xlintimc, and xlintimz for LIN
#       xeigtims, xeigtimd, xeigtimc, and xeigtimz for EIG
#  and exist in the current directory level.
#
#  To remove the output files after the tests have been run, enter
#       make clean
#
#  To re-run specific tests after a make, enter (for example):
#       'rm stime.out; make'  or:
#       'make stime.out' or:
#       'touch stime.in; make' (to re-run the timings.)
#
#       'rm *time.out; make'  (to re-run all the timings.)
#
#######################################################################

include ../make.inc

all:     single complex double complex16
large:	 single_large complex_large double_large complex16_large
small:   single complex double complex16

SEIGTIM= sgeptim.out \
         sneptim.out \
         sseptim.out \
         ssvdtim.out

SEIGTM2= SGEPTIM.out \
         SNEPTIM.out \
         SSEPTIM.out \
         SSVDTIM.out

CEIGTIM= cgeptim.out \
         cneptim.out \
         cseptim.out \
         csvdtim.out

CEIGTM2= CGEPTIM.out \
         CNEPTIM.out \
         CSEPTIM.out \
         CSVDTIM.out

DEIGTIM= dgeptim.out \
         dneptim.out \
         dseptim.out \
         dsvdtim.out

DEIGTM2= DGEPTIM.out \
         DNEPTIM.out \
         DSEPTIM.out \
         DSVDTIM.out

ZEIGTIM= zgeptim.out \
         zneptim.out \
         zseptim.out \
         zsvdtim.out

ZEIGTM2= ZGEPTIM.out \
         ZNEPTIM.out \
         ZSEPTIM.out \
         ZSVDTIM.out

SLINTIM= stime.out \
	 sband.out \
	 stime2.out

SLINTM2= STIME.out \
	 SBAND.out \
	 STIME2.out

CLINTIM= ctime.out \
	 cband.out \
	 ctime2.out

CLINTM2= CTIME.out \
	 CBAND.out \
	 CTIME2.out

DLINTIM= dtime.out \
	 dband.out \
	 dtime2.out

DLINTM2= DTIME.out \
	 DBAND.out \
	 DTIME2.out

ZLINTIM= ztime.out \
	 zband.out \
	 ztime2.out

ZLINTM2= ZTIME.out \
	 ZBAND.out \
	 ZTIME2.out

single:         $(SLINTIM) $(SEIGTIM)
complex:        $(CLINTIM) $(CEIGTIM)
double:         $(DLINTIM) $(DEIGTIM)
complex16:      $(ZLINTIM) $(ZEIGTIM)

single_large:     $(SLINTM2) $(SEIGTM2)
complex_large:    $(CLINTM2) $(CEIGTM2)
double_large:     $(DLINTM2) $(DEIGTM2)
complex16_large:  $(ZLINTM2) $(ZEIGTM2)

#
# ======== SINGLE LIN TIMINGS ===========================

stime.out: stime.in xlintims
	@echo Timing square REAL LAPACK linear equation routines
	./xlintims < stime.in > $@ 2>&1

STIME.out: STIME.in xlintims
	@echo Timing square REAL LAPACK linear equation routines
	./xlintims < STIME.in > $@ 2>&1

sband.out: sband.in xlintims
	@echo Timing banded REAL LAPACK linear equation routines
	./xlintims < sband.in > $@ 2>&1

SBAND.out: SBAND.in xlintims
	@echo Timing banded REAL LAPACK linear equation routines
	./xlintims < SBAND.in > $@ 2>&1

stime2.out: stime2.in xlintims
	@echo Timing rectangular REAL LAPACK linear equation routines
	./xlintims < stime2.in > $@ 2>&1

STIME2.out: STIME2.in xlintims
	@echo Timing rectangular REAL LAPACK linear equation routines
	./xlintims < STIME2.in > $@ 2>&1
#
# ======== COMPLEX LIN TIMINGS ==========================

ctime.out: ctime.in xlintimc
	@echo Timing square COMPLEX LAPACK linear equation routines
	./xlintimc < ctime.in > $@ 2>&1

CTIME.out: CTIME.in xlintimc
	@echo Timing square COMPLEX LAPACK linear equation routines
	./xlintimc < CTIME.in > $@ 2>&1

cband.out: cband.in xlintimc
	@echo Timing banded COMPLEX LAPACK linear equation routines
	./xlintimc < cband.in > $@ 2>&1

CBAND.out: CBAND.in xlintimc
	@echo Timing banded COMPLEX LAPACK linear equation routines
	./xlintimc < CBAND.in > $@ 2>&1

ctime2.out: ctime2.in xlintimc
	@echo Timing rectangular COMPLEX LAPACK linear equation routines
	./xlintimc < ctime2.in > $@ 2>&1

CTIME2.out: CTIME2.in xlintimc
	@echo Timing rectangular COMPLEX LAPACK linear equation routines
	./xlintimc < CTIME2.in > $@ 2>&1
#
# ======== DOUBLE LIN TIMINGS ===========================

dtime.out: dtime.in xlintimd
	@echo Timing square DOUBLE PRECISION LAPACK linear equation routines
	./xlintimd < dtime.in > $@ 2>&1

DTIME.out: DTIME.in xlintimd
	@echo Timing square DOUBLE PRECISION LAPACK linear equation routines
	./xlintimd < DTIME.in > $@ 2>&1

dband.out: dband.in xlintimd
	@echo Timing banded DOUBLE PRECISION LAPACK linear equation routines
	./xlintimd < dband.in > $@ 2>&1

DBAND.out: dband.in xlintimd
	@echo Timing banded DOUBLE PRECISION LAPACK linear equation routines
	./xlintimd < DBAND.in > $@ 2>&1

dtime2.out: dtime2.in xlintimd
	@echo Timing rectangular DOUBLE PRECISION LAPACK linear equation routines
	./xlintimd < dtime2.in > $@ 2>&1

DTIME2.out: DTIME2.in xlintimd
	@echo Timing rectangular DOUBLE PRECISION LAPACK linear equation routines
	./xlintimd < DTIME2.in > $@ 2>&1
#
# ======== COMPLEX16 LIN TIMINGS ========================

ztime.out: ztime.in xlintimz
	@echo Timing square COMPLEX16 LAPACK linear equation routines
	./xlintimz < ztime.in > $@ 2>&1

ZTIME.out: ztime.in xlintimz
	@echo Timing square COMPLEX16 LAPACK linear equation routines
	./xlintimz < ZTIME.in > $@ 2>&1

zband.out: zband.in xlintimz
	@echo Timing banded COMPLEX16 LAPACK linear equation routines
	./xlintimz < zband.in > $@ 2>&1

ZBAND.out: ZBAND.in xlintimz
	@echo Timing banded COMPLEX16 LAPACK linear equation routines
	./xlintimz < ZBAND.in > $@ 2>&1

ztime2.out: ztime2.in xlintimz
	@echo Timing rectangular COMPLEX16 LAPACK linear equation routines
	./xlintimz < ztime2.in > $@ 2>&1

ZTIME2.out: ZTIME2.in xlintimz
	@echo Timing rectangular COMPLEX16 LAPACK linear equation routines
	./xlintimz < ZTIME2.in > $@ 2>&1
#
#
# ======== SINGLE EIG TIMINGS ===========================
#
sgeptim.out: sgeptim.in xeigtims
	@echo GEP: Timing REAL Generalized Nonsymmetric Eigenvalue Problem routines
	./xeigtims < sgeptim.in > $@ 2>&1

SGEPTIM.out: SGEPTIM.in xeigtims
	@echo GEP: Timing REAL Generalized Nonsymmetric Eigenvalue Problem routines
	./xeigtims < SGEPTIM.in > $@ 2>&1

sneptim.out: sneptim.in xeigtims
	@echo NEP: Timing REAL Nonsymmetric Eigenvalue Problem routines
	./xeigtims < sneptim.in > $@ 2>&1

SNEPTIM.out: SNEPTIM.in xeigtims
	@echo NEP: Timing REAL Nonsymmetric Eigenvalue Problem routines
	./xeigtims < SNEPTIM.in > $@ 2>&1

sseptim.out: sseptim.in xeigtims
	@echo SEP: Timing REAL Symmetric Eigenvalue Problem routines
	./xeigtims < sseptim.in > $@ 2>&1

SSEPTIM.out: SSEPTIM.in xeigtims
	@echo SEP: Timing REAL Symmetric Eigenvalue Problem routines
	./xeigtims < SSEPTIM.in > $@ 2>&1

ssvdtim.out: ssvdtim.in xeigtims
	@echo SVD: Timing REAL Singular Value Decomposition routines
	./xeigtims < ssvdtim.in > $@ 2>&1

SSVDTIM.out: SSVDTIM.in xeigtims
	@echo SVD: Timing REAL Singular Value Decomposition routines
	./xeigtims < SSVDTIM.in > $@ 2>&1
#
# ======== COMPLEX EIG TIMINGS ===========================
#
cgeptim.out: cgeptim.in xeigtimc
	@echo GEP: Timing COMPLEX Generalized Nonsymmetric Eigenvalue Problem routines
	./xeigtimc < cgeptim.in > $@ 2>&1

CGEPTIM.out: CGEPTIM.in xeigtimc
	@echo GEP: Timing COMPLEX Generalized Nonsymmetric Eigenvalue Problem routines
	./xeigtimc < cgeptim.in > $@ 2>&1

cneptim.out: cneptim.in xeigtimc
	@echo NEP: Timing COMPLEX Nonsymmetric Eigenvalue Problem routines
	./xeigtimc < cneptim.in > $@ 2>&1

CNEPTIM.out: CNEPTIM.in xeigtimc
	@echo NEP: Timing COMPLEX Nonsymmetric Eigenvalue Problem routines
	./xeigtimc < CNEPTIM.in > $@ 2>&1

cseptim.out: cseptim.in xeigtimc
	@echo SEP: Timing COMPLEX Symmetric Eigenvalue Problem routines
	./xeigtimc < cseptim.in > $@ 2>&1

CSEPTIM.out: CSEPTIM.in xeigtimc
	@echo SEP: Timing COMPLEX Symmetric Eigenvalue Problem routines
	./xeigtimc < CSEPTIM.in > $@ 2>&1

csvdtim.out: csvdtim.in xeigtimc
	@echo SVD: Timing COMPLEX Singular Value Decomposition routines
	./xeigtimc < csvdtim.in > $@ 2>&1

CSVDTIM.out: CSVDTIM.in xeigtimc
	@echo SVD: Timing COMPLEX Singular Value Decomposition routines
	./xeigtimc < CSVDTIM.in > $@ 2>&1
#
# ======== DOUBLE EIG TIMINGS ===========================
#
dgeptim.out: dgeptim.in xeigtimd
	@echo GEP: Timing DOUBLE PRECISION Generalized Nonsymmetric Eigenvalue Problem routines
	./xeigtimd < dgeptim.in > $@ 2>&1

DGEPTIM.out: DGEPTIM.in xeigtimd
	@echo GEP: Timing DOUBLE PRECISION Generalized Nonsymmetric Eigenvalue Problem routines
	./xeigtimd < dgeptim.in > $@ 2>&1

dneptim.out: dneptim.in xeigtimd
	@echo NEP: Timing DOUBLE PRECISION Nonsymmetric Eigenvalue Problem routines
	./xeigtimd < dneptim.in > $@ 2>&1

DNEPTIM.out: DNEPTIM.in xeigtimd
	@echo NEP: Timing DOUBLE PRECISION Nonsymmetric Eigenvalue Problem routines
	./xeigtimd < DNEPTIM.in > $@ 2>&1

dseptim.out: dseptim.in xeigtimd
	@echo SEP: Timing DOUBLE PRECISION Symmetric Eigenvalue Problem routines
	./xeigtimd < dseptim.in > $@ 2>&1

DSEPTIM.out: DSEPTIM.in xeigtimd
	@echo SEP: Timing DOUBLE PRECISION Symmetric Eigenvalue Problem routines
	./xeigtimd < DSEPTIM.in > $@ 2>&1

dsvdtim.out: dsvdtim.in xeigtimd
	@echo SVD: Timing DOUBLE PRECISION Singular Value Decomposition routines
	./xeigtimd < dsvdtim.in > $@ 2>&1

DSVDTIM.out: DSVDTIM.in xeigtimd
	@echo SVD: Timing DOUBLE PRECISION Singular Value Decomposition routines
	./xeigtimd < DSVDTIM.in > $@ 2>&1
#
# ======== COMPLEX16 EIG TIMINGS ===========================
#
zgeptim.out: zgeptim.in xeigtimz
	@echo GEP: Timing COMPLEX16 Generalized Nonsymmetric Eigenvalue Problem routines
	./xeigtimz < zgeptim.in > $@ 2>&1

ZGEPTIM.out: ZGEPTIM.in xeigtimz
	@echo GEP: Timing COMPLEX16 Generalized Nonsymmetric Eigenvalue Problem routines
	./xeigtimz < zgeptim.in > $@ 2>&1

zneptim.out: zneptim.in xeigtimz
	@echo NEP: Timing COMPLEX16 Nonsymmetric Eigenvalue Problem routines
	./xeigtimz < zneptim.in > $@ 2>&1

ZNEPTIM.out: ZNEPTIM.in xeigtimz
	@echo NEP: Timing COMPLEX16 Nonsymmetric Eigenvalue Problem routines
	./xeigtimz < ZNEPTIM.in > $@ 2>&1

zseptim.out: zseptim.in xeigtimz
	@echo SEP: Timing COMPLEX16 Symmetric Eigenvalue Problem routines
	./xeigtimz < zseptim.in > $@ 2>&1

ZSEPTIM.out: ZSEPTIM.in xeigtimz
	@echo SEP: Timing COMPLEX16 Symmetric Eigenvalue Problem routines
	./xeigtimz < ZSEPTIM.in > $@ 2>&1

zsvdtim.out: zsvdtim.in xeigtimz
	@echo SVD: Timing COMPLEX16 Singular Value Decomposition routines
	./xeigtimz < zsvdtim.in > $@ 2>&1

ZSVDTIM.out: ZSVDTIM.in xeigtimz
	@echo SVD: Timing COMPLEX16 Singular Value Decomposition routines
	./xeigtimz < ZSVDTIM.in > $@ 2>&1
# ==============================================================================

xlintims:
	cd LIN/LINSRC ; $(MAKE) single
	cd LIN ; $(MAKE) single

xlintimc:
	cd LIN/LINSRC ; $(MAKE) complex
	cd LIN ; $(MAKE) complex

xlintimd:
	cd LIN/LINSRC ; $(MAKE) double
	cd LIN ; $(MAKE) double

xlintimz:
	cd LIN/LINSRC ; $(MAKE) complex16
	cd LIN ; $(MAKE) complex16


xeigtims:
	cd EIG/EIGSRC ; $(MAKE) single

=== old/lapack-test/play/Makefile ===

#
# Makefile
#
# Field G. Van Zee
# 
# Makefile for libflame test suite driver.
#

#
# --- Include libflame config makefile fragment --------------------------------
#

# Determine the path to the libflame config makefile fragment. We'll use
# several variables defined there.
BUILD_DIRPATH       := ../../build
CONFIG_DIRPATH      := ../../config
HOST                := $(shell sh $(BUILD_DIRPATH)/ac-utils/config.guess)
CONFIG_MK_FRAGMENT  := $(CONFIG_DIRPATH)/$(HOST)/config.mk

# Include the definitions in the config makefile fragment.
-include $(CONFIG_MK_FRAGMENT)

#
# --- Optional overrides -------------------------------------------------------
#

# Uncomment and modify these definitions if you wish to override the values
# present in the master config makefile fragment.
# CC             := gcc
# LINKER         := $(CC)
# CFLAGS         := -g -O2 -Wall -Wno-comment
# LDFLAGS        := 
INSTALL_PREFIX := /Users/kyungjoo/Lib/FLAME

#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLAS implementation path. A BLAS library must be given in order to run
# the libflame test suite. Modify these definitions if needed.
LIBBLAS        := -L/opt/local/lib -lcblas -lf77blas -latlas -lf2c 

# LAPACK implementation path. These values only matter if libflame was
# configured with the external-lapack-interfaces option enabled. Modify
# these definitions if needed.
LIBLAPACK      :=  
# -L/opt/local/lib -llapack

#
# --- General build definitions ------------------------------------------------
#

FLA_LIB_PATH   := ../../lib/$(HOST)
FLA_INC_PATH   := ../../include_local
LIBFLAME       := $(FLA_LIB_PATH)/libflame.a

CFLAGS         += -I$(FLA_INC_PATH) -I.

TEST  = tridiag_realify_diagonals
TESTS = qr rq lq ql qr_piv \
	pivot normalize bidiag_realify_diagonals tridiag_realify_diagonals \
	extract_component givens constant \
	bidiag bidiag_ext bidiag_external tridiag tridiag_external ls_biqr \
	svd bsvd  bsvd_ext svd_ext

%.o : %.c
	@echo "Compiling $<"
	$(CC) $(CFLAGS) -c $< -o $@

one : $(TEST).o
	@echo "Linking   $<"
	$(LINKER) -o $(TEST).x $(TEST).o  $(LDFLAGS) $(LIBFLAME) $(LIBLAPACK) $(LIBBLAS)

all :
	@for e in $(TESTS) ; do \
		make one TEST=$$e ;\
	done

clean :
	@rm -f *.o *~
	@for t in $(TESTS) ; do rm -f $$t.x ; done
	@for d in $(DIRS); do (cd $$d; make clean ); done

=== netlib-test/lapack-3.4.2/BLAS/SRC/Makefile ===
include ../../make.inc

#######################################################################
#  This is the makefile to create a library for the BLAS.
#  The files are grouped as follows:
#
#       SBLAS1 -- Single precision real BLAS routines
#       CBLAS1 -- Single precision complex BLAS routines
#       DBLAS1 -- Double precision real BLAS routines
#       ZBLAS1 -- Double precision complex BLAS routines
#
#       CB1AUX -- Real BLAS routines called by complex routines
#       ZB1AUX -- D.P. real BLAS routines called by d.p. complex
#                 routines
#
#      ALLBLAS -- Auxiliary routines for Level 2 and 3 BLAS
#
#       SBLAS2 -- Single precision real BLAS2 routines
#       CBLAS2 -- Single precision complex BLAS2 routines
#       DBLAS2 -- Double precision real BLAS2 routines
#       ZBLAS2 -- Double precision complex BLAS2 routines
#
#       SBLAS3 -- Single precision real BLAS3 routines
#       CBLAS3 -- Single precision complex BLAS3 routines
#       DBLAS3 -- Double precision real BLAS3 routines
#       ZBLAS3 -- Double precision complex BLAS3 routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Note that these commands are not safe for parallel builds.
#
#  Alternatively, the commands
#       make all
#  or
#       make
#  without any arguments creates a library of all four precisions.
#  The name of the library is held in BLASLIB, which is set in the
#  top-level make.inc
#
#  To remove the object files after the library is created, enter
#       make clean
#  To force the source files to be recompiled, enter, for example,
#       make single FRC=FRC
#
#---------------------------------------------------------------------
#
#  Edward Anderson, University of Tennessee
#  March 26, 1990
#  Susan Ostrouchov, Last updated September 30, 1994
#  ejr, May 2006.
#
#######################################################################

all: $(BLASLIB)
 
#---------------------------------------------------------
#  Comment out the next 6 definitions if you already have
#  the Level 1 BLAS.
#---------------------------------------------------------
SBLAS1 = isamax.o sasum.o saxpy.o scopy.o sdot.o snrm2.o \
	srot.o srotg.o sscal.o sswap.o sdsdot.o srotmg.o srotm.o
$(SBLAS1): $(FRC)

CBLAS1 = scabs1.o scasum.o scnrm2.o icamax.o caxpy.o ccopy.o \
	cdotc.o cdotu.o csscal.o crotg.o cscal.o cswap.o csrot.o
$(CBLAS1): $(FRC)

DBLAS1 = idamax.o dasum.o daxpy.o dcopy.o ddot.o dnrm2.o \
	drot.o drotg.o dscal.o dsdot.o dswap.o drotmg.o drotm.o
$(DBLAS1): $(FRC)

ZBLAS1 = dcabs1.o dzasum.o dznrm2.o izamax.o zaxpy.o zcopy.o \
	zdotc.o zdotu.o zdscal.o zrotg.o zscal.o zswap.o zdrot.o
$(ZBLAS1): $(FRC)

CB1AUX = isamax.o sasum.o saxpy.o scopy.o snrm2.o sscal.o
$(CB1AUX): $(FRC)

ZB1AUX = idamax.o dasum.o daxpy.o dcopy.o dnrm2.o dscal.o
$(ZB1AUX): $(FRC)

#---------------------------------------------------------------------
#  The following line defines auxiliary routines needed by both the
#  Level 2 and Level 3 BLAS.  Comment it out only if you already have
#  both the Level 2 and 3 BLAS.
#---------------------------------------------------------------------
ALLBLAS  = lsame.o xerbla.o xerbla_array.o
$(ALLBLAS) : $(FRC)

#---------------------------------------------------------
#  Comment out the next 4 definitions if you already have
#  the Level 2 BLAS.
#---------------------------------------------------------
SBLAS2 = sgemv.o sgbmv.o ssymv.o ssbmv.o sspmv.o \
	strmv.o stbmv.o stpmv.o strsv.o stbsv.o stpsv.o \
	sger.o ssyr.o sspr.o ssyr2.o sspr2.o
$(SBLAS2): $(FRC)

CBLAS2 = cgemv.o cgbmv.o chemv.o chbmv.o chpmv.o \
	ctrmv.o ctbmv.o ctpmv.o ctrsv.o ctbsv.o ctpsv.o \
	cgerc.o cgeru.o cher.o chpr.o cher2.o chpr2.o
$(CBLAS2): $(FRC)

DBLAS2 = dgemv.o dgbmv.o dsymv.o dsbmv.o dspmv.o \
	dtrmv.o dtbmv.o dtpmv.o dtrsv.o dtbsv.o dtpsv.o \
	dger.o dsyr.o dspr.o dsyr2.o dspr2.o
$(DBLAS2): $(FRC)

ZBLAS2 = zgemv.o zgbmv.o zhemv.o zhbmv.o zhpmv.o \
	ztrmv.o ztbmv.o ztpmv.o ztrsv.o ztbsv.o ztpsv.o \
	zgerc.o zgeru.o zher.o zhpr.o zher2.o zhpr2.o
$(ZBLAS2): $(FRC)

#---------------------------------------------------------
#  Comment out the next 4 definitions if you already have
#  the Level 3 BLAS.
#---------------------------------------------------------
SBLAS3 = sgemm.o ssymm.o ssyrk.o ssyr2k.o strmm.o strsm.o 
$(SBLAS3): $(FRC)

CBLAS3 = cgemm.o csymm.o csyrk.o csyr2k.o ctrmm.o ctrsm.o \
	chemm.o cherk.o cher2k.o
$(CBLAS3): $(FRC)

DBLAS3 = dgemm.o dsymm.o dsyrk.o dsyr2k.o dtrmm.o dtrsm.o
$(DBLAS3): $(FRC)

ZBLAS3 = zgemm.o zsymm.o zsyrk.o zsyr2k.o ztrmm.o ztrsm.o \
	zhemm.o zherk.o zher2k.o
$(ZBLAS3): $(FRC)

ALLOBJ=$(SBLAS1) $(SBLAS2) $(SBLAS3) $(DBLAS1) $(DBLAS2) $(DBLAS3)	\
	$(CBLAS1) $(CBLAS2) $(CBLAS3) $(ZBLAS1) \
	$(ZBLAS2) $(ZBLAS3) $(ALLBLAS)

$(BLASLIB): $(ALLOBJ)
	$(ARCH) $(ARCHFLAGS) $@ $(ALLOBJ)
	$(RANLIB) $@

single: $(SBLAS1) $(ALLBLAS) $(SBLAS2) $(SBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(SBLAS1) $(ALLBLAS) \
	$(SBLAS2) $(SBLAS3)
	$(RANLIB) $(BLASLIB)

double: $(DBLAS1) $(ALLBLAS) $(DBLAS2) $(DBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(DBLAS1) $(ALLBLAS) \
	$(DBLAS2) $(DBLAS3)
	$(RANLIB) $(BLASLIB)

complex: $(CBLAS1) $(CB1AUX) $(ALLBLAS) $(CBLAS2) $(CBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(CBLAS1) $(CB1AUX) \
	$(ALLBLAS) $(CBLAS2) $(CBLAS3)
	$(RANLIB) $(BLASLIB)

complex16: $(ZBLAS1) $(ZB1AUX) $(ALLBLAS) $(ZBLAS2) $(ZBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(ZBLAS1) $(ZB1AUX) \
	$(ALLBLAS) $(ZBLAS2) $(ZBLAS3)
	$(RANLIB) $(BLASLIB)

FRC:
	@FRC=$(FRC)

clean:
	rm -f *.o

.f.o: 
	$(FORTRAN) $(OPTS) -c $< -o $@

=== debian/changelog ===
libflame (5.2.0-5.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:51:55 +1100

libflame (5.2.0-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062315

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 12:00:57 +0000

libflame (5.2.0-5) unstable; urgency=medium

  * Amend FTBS twice in a row. (Closes: #1045506)

 -- Mo Zhou <lumin@debian.org>  Wed, 13 Sep 2023 18:20:47 -0400

libflame (5.2.0-4) unstable; urgency=medium

  * rules: fix the logic for dh_auto_test.
  * Disable autopkgtest with numpy, scipy, and octave. They are not yet
    compiled against libflame. (Closes: #1019525, #1019478, #1018074)

 -- Mo Zhou <lumin@debian.org>  Tue, 25 Oct 2022 12:39:03 -0400

libflame (5.2.0-3) unstable; urgency=medium

  * Autopkgtest: add the missing deps python3-hypothesis (Closes: #970899)

 -- Mo Zhou <lumin@debian.org>  Thu, 01 Oct 2020 15:22:19 +0800

libflame (5.2.0-2) unstable; urgency=medium

  * Upload to unstable (no change).

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Jul 2020 17:00:51 +0800

libflame (5.2.0-1) experimental; urgency=medium

  * Initial release. (Closes: #945918)

 -- Mo Zhou <lumin@debian.org>  Fri, 15 May 2020 20:41:14 +0800

=== debian/control ===
Source: libflame
Section: math
Homepage: https://github.com/flame/libflame
Priority: optional
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/libflame
Vcs-Git: https://salsa.debian.org/science-team/libflame.git
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Rules-Requires-Root: no
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               gfortran,
               libblas-dev | libblas.so.3,
               liblapack-dev | liblapack.so.3,
               python3-minimal

Package: libflame1t64
Provides: ${t64:Provides}
Replaces: libflame1
Breaks: libflame1 (<< ${source:Version})
Section: libs
Architecture: any
Depends: libblas3 | libblas.so.3, ${misc:Depends}, ${shlibs:Depends}
#Provides: liblapack.so.3
Description: High-performance object-based library for DLA computations (shlib)
 libflame is a portable library for dense matrix computations, providing
 much of the functionality present in LAPACK, developed by current and
 former members of the Science of High-Performance Computing (SHPC) group
 in the Institute for Computational Engineering and Sciences at The
 University of Texas at Austin. libflame includes a compatibility layer,
 lapack2flame, which includes a complete LAPACK implementation.
 .
 This package contains the shared object.

Package: libflame-dev
Section: libdevel
Architecture: any
Depends: libflame1t64 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
#Provides: liblapack.so
Description: High-performance object-based library for DLA computations (dev)
 libflame is a portable library for dense matrix computations, providing
 much of the functionality present in LAPACK, developed by current and
 former members of the Science of High-Performance Computing (SHPC) group
 in the Institute for Computational Engineering and Sciences at The
 University of Texas at Austin. libflame includes a compatibility layer,
 lapack2flame, which includes a complete LAPACK implementation.
 .
 This package contains the static library and the development files.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export CFLAGS=$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
export FFLAGS=$(shell dpkg-buildflags --get FFLAGS)

# [[ common flags ]]
# TODO: openmp or pthreads, or both?
# https://github.com/flame/libflame/issues/28#issuecomment-561791815
CONFFLAGS = \
	--prefix=/usr \
	--libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/ \
	--enable-max-arg-list-hack \
	--enable-dynamic-build \
	--enable-lapack2flame \
	--enable-verbose-make-output \
	--enable-multithreading=openmp \
	--enable-supermatrix \
	--enable-memory-alignment=16 \
	--enable-ldim-alignment

# [[ arch-specific flags ]]
ifeq (amd64,$(DEB_HOST_ARCH))
CONFFLAGS+= --enable-vector-intrinsics=sse
endif

%:
	dh $@ -Smakefile

override_dh_clean:
	dh_auto_clean
	dh_clean -X.orig -X.bak
	-$(RM) libflame1t64.install libflame1t64.links
	-$(RM) libflame1t64.postinst libflame1t64.prerm
	-$(RM) -rf test/obj/
	-$(RM) test/test_libflame.x

override_dh_autoreconf:

override_dh_auto_configure:
	./configure $(CONFFLAGS)
	sed -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
		< debian/libflame1t64.install.in \
		> debian/libflame1t64.install
	#sed -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
	#	< debian/libflame1t64.links.in \
	#	> debian/libflame1t64.links
	#sed -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
	#	< debian/libflame1t64.postinst.in \
	#	> debian/libflame1t64.postinst
	#sed -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
	#	< debian/libflame1t64.prerm.in \
	#	> debian/libflame1t64.prerm

override_dh_auto_build:
	dh_auto_build --parallel -- V=1

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir -p test/obj
	dh_auto_build --parallel -- -C test
	cd test; ./test_libflame.x
endif

=== debian/tests/control ===
Tests: runtest.sh
Depends: libblas-dev, liblapack-dev, @, @builddeps@
Restrictions: allow-stderr

#Test-Command: python3 -c "import numpy as np; np.test('full', verbose=3)"
#Depends: build-essential,
#         libblas-dev,
#         liblapack-dev,
#         python3-distutils,
#         python3-numpy,
#         python3-pytest,
#         python3-hypothesis,
#Restrictions: allow-stderr
#Features: test-name=numpy-with-default
#
#Test-Command: python3 -c "import scipy as sp; sp.test('full', verbose=3)"
#Depends: build-essential,
#         libblas-dev,
#         liblapack-dev,
#         python3-distutils,
#         python3-pytest,
#         python3-hypothesis,
#         python3-scipy
#Restrictions: allow-stderr
#Features: test-name=scipy-with-default
#
#Test-Command: octave --eval '__run_test_suite__'
#Depends: libblas-dev, liblapack-dev, octave
#Restrictions: allow-stderr
#Features: test-name=octave-with-default
#
#Test-Command: python3 -c "import numpy as np; np.test('full', verbose=3)"
#Depends: build-essential,
#         libblas-dev,
#         liblapack-dev,
#         python3-distutils,
#         python3-numpy,
#         python3-pytest,
#         python3-hypothesis,
#         @,
#         @builddeps@
#Restrictions: allow-stderr
#Features: test-name=numpy-with-libflame
#
#Test-Command: python3 -c "import scipy as sp; sp.test('full', verbose=3)"
#Depends: build-essential,
#         libblas-dev,
#         liblapack-dev,
#         python3-distutils,
#         python3-pytest,
#         python3-hypothesis,
#         python3-scipy,
#         @,
#         @builddeps@
#Restrictions: allow-stderr
#Features: test-name=scipy-with-libflame
#
#Test-Command: octave --eval '__run_test_suite__'
#Depends: libblas-dev, liblapack-dev, octave, @, @builddeps@
#Restrictions: allow-stderr
#Features: test-name=octave-with-libflame

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libflame-$1.tar.gz%" \
https://github.com/flame/libflame/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
